package com.zanxiang.game.module.manage.rpc.impl;

import com.zanxiang.game.module.base.pojo.dto.SendMsgDto;
import com.zanxiang.game.module.base.rpc.SendMsgRpc;
import com.zanxiang.game.module.manage.service.ISendMsgTaskService;
import com.zanxiang.game.module.mybatis.entity.SendMsgTask;
import com.zanxiang.module.util.pojo.ResultVO;
import lombok.extern.slf4j.Slf4j;
import org.apache.dubbo.config.annotation.DubboService;

import javax.annotation.Resource;

@DubboService
@Slf4j
public class SendMsgImpl implements SendMsgRpc {

    @Resource
    private ISendMsgTaskService sendMsgTaskService;

    @Override
    public ResultVO<Boolean> sendMsg(SendMsgDto sendMsgDto) {
        try {
            // 数据校验
            if (sendMsgDto == null || sendMsgDto.getMsg() == null || sendMsgDto.getGameName() == null || sendMsgDto.getCreateBy() == null || sendMsgDto.getRoles() == null || sendMsgDto.getRoles().isEmpty()) {
                return ResultVO.fail("参数不能为空");
            }
            //创建任务
            SendMsgTask sendMsgTask = createSendMsgTask(sendMsgDto);
            //保存任务
            sendMsgTaskService.save(sendMsgTask);
            //todo：发送消息
            log.info("发送消息成功");
            return ResultVO.ok();
        } catch (Exception e) {
            log.error("发送消息异常, sendMsgDto : {}, e : {}", sendMsgDto, e.getMessage());
            return ResultVO.fail("发送消息异常");
        }
    }

    private SendMsgTask createSendMsgTask(SendMsgDto sendMsgDto) {
//        SendMsgTask sendMsgTask = new SendMsgTask();
//        sendMsgTask.setTaskName(sendMsgDto.getTaskName());
//        sendMsgTask.setMsg(sendMsgDto.getMsg());
//        sendMsgTask.setTaskCondition(sendMsgDto.getSendConditionJson());
//        sendMsgTask.setGameName(sendMsgDto.getGameName());
//        sendMsgTask.setCreateBy(sendMsgDto.getCreateBy());
//        sendMsgTask.setCreateTime(LocalDate.now(ZoneId.of("UTC")));
//        sendMsgTask.setRoleIds(String.join(",", sendMsgDto.getRoles()));
//        return sendMsgTask;
        return null;
    }
}
